( function( window, $ ) {
    $( document ).ready(function() {

        // Decorate constituent primary email with a required star
        $('label[for="mappedFields_primary_email"]').append( ' <span class="required">*</span>' )

        var teamraiser_feed_fields = '#gaddon-setting-row-teamraiserEventId,#gaddon-setting-row-teamraiserParticipationTypeId';

        $(teamraiser_feed_fields).children('th').append('<span class="required">*</span>');

        $('#constituent').on('change', function(){
            if ( $(this).is(':checked') ) {
                $('#gaddon-setting-row-mappedFields').show('medium');
            } else {
                $('#gaddon-setting-row-mappedFields').hide('medium');
                var inputs = $('#gaddon-setting-row-mappedFields td');

                // remove the required attribute from the fields that are hidden
                $.map(inputs, function(node,index){
                    var $node = $(node);
                    var select = $(node).find('select');
                    select.removeAttr('required');
                    var label = $(node).find('label span.required').remove();
                });
            }
        }).trigger('change');

        // Validate via JS
        $('#tab_gravityforms-luminate form#gform-settings').on( 'submit', function() {

            if ( ! isValidConstituentEmailField( true ) ) {
                alert( 'You must specify a field for Primary Email if mapping constituents.' );

                return false;
            }

        });

        $('#group').on('change', function(){
            if ( $(this).is(':checked') ) {
                $('#gaddon-setting-row-groups').show('medium');
            } else {
                $('#gaddon-setting-row-groups').hide('medium');
            }
        }).trigger('change');

        $('#teamraiser').on('change', function(){
            if ( $(this).is(':checked') ) {
                $(teamraiser_feed_fields).show('medium').find('input').attr('required', 'required').on('oninvalid', function(){
                    $(this).setCustomValidity('You must specify the Event ID and Participation Type ID when mapping to TeamRaiser');
                });
                $('#gaddon-setting-row-teamraiserMappedFields').show('medium');
            } else {
                //$('#gaddon-setting-row-teamraiserEventId span.required, #gaddon-setting-row-teamraiserParticipationTypeId span.required').remove();

                $(teamraiser_feed_fields).hide('medium').find('input').removeAttr('required');
                $('#gaddon-setting-row-teamraiserMappedFields').hide('medium');
                /*var inputs = $('#gaddon-setting-row-teamraiserMappedFields td');

                // remove the required attribute from the fields that are hidden
                $.map(inputs, function(node,index){
                    var $node = $(node);
                    var select = $(node).find('select');
                    select.removeAttr('required');
                    var label = $(node).find('label span.required').remove();
                });*/
            }
        }).trigger('change');

        var $initial_teamraiser_event_id = $('#teamraiserEventId').val();
        var $initial_teamraiser_part_type_id = $('#teamraiserParticipationTypeId').val();

        // if the user changes the event ID, reset the survey questions so it forces the user to choose the event mapping survey questions again since each participation type can have it's own set of survey questions
        $('#teamraiserEventId').on('blur',function(){
            var new_value = $(this).val();

            if ( new_value !== $initial_teamraiser_event_id ) {
                var mapping_fields = $('#gaddon-setting-row-teamraiserMappedFields select');

                $.map(mapping_fields, function(node,index) {
                    var $element = $(node);

                    if ($element.attr('name').indexOf('teamraiserMappedFields_survey_question_id')) {
                        $element.val('');
                    }
                });
            }
        });

        // if the user changes the participation type ID, reset the survey questions so it forces the user to choose the event mapping survey questions again since each participation type can have it's own set of survey questions
        $('#teamraiserParticipationTypeId').on('blur',function(){
            var new_value = $(this).val();

            if ( new_value !== $initial_teamraiser_part_type_id ) {
                var mapping_fields = $('#gaddon-setting-row-teamraiserMappedFields select');

                $.map(mapping_fields, function(node,index) {
                    var $element = $(node);

                    if ($element.attr('name').indexOf('teamraiserMappedFields_survey_question_id')) {
                        $element.val('');
                    }
                });
            }
        });

        if (!$('#survey').is(':checked') || $('#listSurveys').val().length <= 0) {
            $('#gaddon-setting-row-surveyMappedFields').hide();
        }

        $('#survey').on('change', function(){
            if ( $(this).is(':checked') ) {
                $('#gaddon-setting-row-listSurveys').show('medium');
                if ($('#listSurveys').val().length > 0 && $('#gaddon-setting-row-surveyMappedFields table').length <= 0) {
                    loadSurveyQuestions($('#listSurveys').val());
                }
            } else {
                $('#gaddon-setting-row-listSurveys').hide('medium');
                $('#listSurveys').prop('selectedIndex',0);
                $('#gaddon-setting-row-surveyMappedFields').hide('medium');
                $('#gaddon-setting-row-surveyMappedFields .settings-field-map-table').remove('medium');
            }
        }).trigger('change');

        var saved_survey = $('#gaddon-setting-row-surveyMappedFields .settings-field-map-table tbody').html();

        var saved_survey_id = $('#listSurveys').val();

        $('#listSurveys').on('change', function(){
            var survey = $(this).val();
            // reload the saved mapping if we switch a form and re-switch back to that form after mapping
            if (survey == saved_survey_id) {
                $('#gaddon-setting-row-surveyMappedFields .settings-field-map-table tbody').html(saved_survey);

                return true;
            }

            if (survey.length > 0) {
                loadSurveyQuestions(survey);
            } else {
                $('#gaddon-setting-row-surveyMappedFields').hide();
            }
        });

        function loadSurveyQuestions(survey_id){
            var post_data = {
                'action': 'get_luminate_survey_questions',
                'surveyId': survey_id
            };

            // since 2.8 ajaxurl is always defined in the admin header and points to admin-ajax.php
            // Set a timeout on adding loaders to table. Wait till everything is loaded since this was broken
            // before the release of version 1.2.0
            setTimeout( function() {
                $('#gaddon-setting-row-surveyMappedFields > td').prepend('<div class="loader-inner ball-pulse"></div>').find('.settings-field-map-table').hide();
                $('.loader-inner').loaders();
            }, 200 );

            $.ajax({
                data: post_data,
                url: ajaxurl,
                method: 'POST',
                dataType: 'html',
                success: function(response, status, xhr) {
                    $('#gaddon-setting-row-surveyMappedFields > td').html(response);
                    $('#gaddon-setting-row-surveyMappedFields').show();
                }
            }).always(function(xhr, status, xhr_error) {
                var current_gravity_form_fields = $('#gaddon-setting-row-mappedFields select').first();
                var $survey_questions = $('.gravityform-fields');
                // in order to make the survey question appears in the same dropdown format as non-dynamic fields, copy
                // the styles from a constituent dropdowns
                $.map($survey_questions, function(node, index) {
                    var $question = $(node);
                    var question_name = $(node).data('survey-field-name');
                    // copy the gravity form fields dropdown from the constituent section and modify elements to match the survey qyestions
                    var gravityform_field_name = current_gravity_form_fields.clone().prop('id', question_name).prop('name', '_gaddon_setting_' + question_name);

                    // append the modified dropdown to the survey mapping table
                    $question.html(gravityform_field_name);
                });
            });
        }

        /**
         * We need to check via JS if an email address has been mapped if the Constituents mapped is enabled
         * We can't just set constituent email to 'required' in the PHP for the form because we may only be mapping Surveys
         */
        function isValidConstituentEmailField( focusIfFalse ) {

            if ( $('#gaddon-setting-checkbox-choice-constituent > .gaddon-checkbox').is(':checked' ) ) {
                if ( jQuery('#mappedFields_primary_email option:first-child').is(':selected') ) {
                    jQuery('#mappedFields_primary_email').focus();
                    return false;
                }
            }

            return true;
        }

        /**
         * Remove unselected feed groups from getting submitted to PHP/processed. If there are a lot of email groups
         * that can be submitted but aren't selected, PHP may throw an error saying that the max_input_vars
         * has been exceeded since we could post over 1000 inputs with most of them being empty.
         */
        function removeUnselectedGroupsFromProcessing() {
            var $feed_form = $( '#form_settings #gform-settings' ).addClass( 'not-ready' ),
                $feed_form_submit = $feed_form.find( 'input[type="submit"]' );
            $feed_form_submit.on( 'click submit', function( e ) {
                if ( $feed_form.hasClass( 'not-ready' ) ) {
                    e.preventDefault();
                    $feed_form.removeClass( 'not-ready' );
                    var checkboxes = $('#gaddon-setting-row-groups input');

                    $.map( checkboxes, function( node, index ) {
                        var $node = $( node );

                        if ( $node.prop( 'type' ).toLowerCase() == 'checkbox' && $node.prop( 'checked' ) == false) {
                            $node.prop( 'disabled', true );
                            $node.prev().prop( 'disabled', true );
                        }
                    } );

                    console.log($feed_form.find( 'input[type="submit"]' ));
                    $feed_form_submit.click();
                    return true;
                }

                return true;

            } );
        }

        removeUnselectedGroupsFromProcessing();

        /**
         * Add the ability for users to reveal the password field for the Luminate fields
         */
        function reveal_password() {
            $( 'input[type="password"]' ).hideShowPassword(true, true);
        }
        reveal_password();

    });
} )( window, window.jQuery || window.$ || window.Zepto );